﻿Function Get-MemberExtension
{
  $xml = New-Object xml

  Function Get-SingleExtension
  {
    param
    (
      $Node,

      $FilePath,

      $typename
    )

    $o = 1 | Select-Object -Property MemberName, ExtensionType, TypeName, Extension, DefiningPath
    $o.DefiningPath = $FilePath
    $o.TypeName = $typename
    $o.Extension = $node.InnerXML
    $o.MemberName = $node.FirstChild.'#text'
    $o.ExtensionType = $node.LocalName

    $o
  }

  $host.Runspace.InitialSessionState.Types |
  Select-Object -ExpandProperty FileName |
  ForEach-Object {
    $FilePath = $_
    $xml.load($FilePath)
    $xml.Types.Type |
    ForEach-Object {
      $typename = $_.Name
      $_.Members | ForEach-Object {
        if ($_.hasChildNodes)
        {
          $child = $_.FirstChild
          do
          {
            Get-SingleExtension $child $FilePath $typename
            $child = $child.NextSibling
          } while ($child)
        }
      }
    }
  } | 
  Sort-Object -Property MemberName
}

Get-MemberExtension | Out-GridView


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
