﻿$code = {
  Function Get-WMIHelpLocation
  {
    param
    (
      $WMIClassName
    )

    $uri = 'http://www.bing.com/search?q={0}+site:msdn.microsoft.com' -f $WMIClassName
    (Invoke-WebRequest -Uri $uri -UseBasicParsing).Links |
    Where-Object href -Like 'http://msdn.microsoft.com*' |
    Select-Object -ExpandProperty href -First 1
  }

  if (-not $args[0])
  {
    $types = $this | Get-Member | Select-Object -ExpandProperty TypeName | Sort-Object -Unique
  }
  else
  {
    $types = Get-Member -InputObject $this | Select-Object -ExpandProperty TypeName | Sort-Object -Unique
  }

  $types  |
  ForEach-Object {
    if ($_ -like '*#root*')
    {
      $WMIClassName = $_.Split('#')[-1].Split('\')[-1]
      Write-Host $WMIClassName
      $url = Get-WMIHelpLocation -WMIClassName $WMIClassName
    }
    else
    {
      $template = 'http://msdn.microsoft.com/de-de/library/{0}(v=vs.80).aspx'
      $url = $template -f $_
    }

    try { Start-Process $url -ErrorAction SilentlyContinue } catch {}
  }
}

Update-TypeData -MemberType ScriptMethod -MemberName GetHelp -Value $code -TypeName System.Object -Force


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
