﻿$server1 = '\\storage1'
$server2 = '\\powershellpc'

$fileList1 = Get-ChildItem $server1\c$\windows\system32\*.dll |
  Sort-Object -Property Name |
  # eine neue Eigenschaft namens "ComputerName" anfügen und den Herkunftsserver darin angeben:
  Add-Member -MemberType NoteProperty -Name ComputerName -Value $server1 -passThru |
  Add-Member -MemberType ScriptProperty -Name Version -Value { $this.VersionInfo.ProductVersion } -PassThru

$fileList2 = Get-ChildItem $server2\c$\windows\system32\*.dll |
  Sort-Object -Property Name |
  # eine neue Eigenschaft namens "ComputerName" anfügen und den Herkunftsserver darin angeben:
  Add-Member -MemberType NoteProperty -Name ComputerName -Value $server2 -passThru |
  Add-Member -MemberType ScriptProperty -Name Version -Value { $this.VersionInfo.ProductVersion } -PassThru

# Unterschiedliche Dateien finden (basierend auf "Name" und "Length") und Objekte mit -passThru
# weitergeben:
Compare-Object -ReferenceObject $fileList1 -DifferenceObject $fileList2 -Property Name, Version -PassThru |
  Sort-Object -Property Name |
  Select-Object -Property ComputerName, Name, Version |
  Out-GridView


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
