﻿Function Use-Culture
{
  param
  (
    [ScriptBlock]
    [Parameter(Mandatory=$true)]
    $code,

    [System.Globalization.CultureInfo]
    $culture='en-US'
  )

  trap {
    [System.Threading.Thread]::CurrentThread.CurrentCulture = $currentCulture
  }

  $currentCulture = [System.Threading.Thread]::CurrentThread.CurrentCulture
  [System.Threading.Thread]::CurrentThread.CurrentCulture = $culture
  Invoke-Command $code
  [System.Threading.Thread]::CurrentThread.CurrentCulture = $currentCulture
}

$code = {
  $excel = New-Object -ComObject Excel.Application
  $workbook = $excel.Workbooks.Add()
  $excel.Visible = $True
  $excel.Cells.Item(1,1) = 'Service Name'
  $excel.Cells.Item(1,2) = 'Service Status'
  $excel.Cells.Item(1,3) = 'Service Status'

  $i = 2
  Get-Service |
  ForEach-Object {
    $excel.Cells.Item($i,1) = $_.name
    $excel.Cells.Item($i,2) = $_.status
    $excel.Cells.Item($i,3) = "$($_.status)"
    $i=$i+1
  }
}

Use-Culture $code


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
