﻿# Wetterdienst ansprechen:
$wetter = New-WebServiceProxy -Uri http://www.webservicex.com/globalweather.asmx?WSDL

# Wetterdaten abrufen:
$hannover = [XML]$wetter.GetWeather('Hannover', 'Germany')
$mallorca = [XML]$wetter.GetWeather('Palma', 'Spain')
$celsiusHannover =
if ($hannover.CurrentWeather.Temperature -match 'F \((.*?) C\)')
{
  $Matches[1]
}

$celsiusPalma =
if ($mallorca.CurrentWeather.Temperature -match 'F \((.*?) C\)')
{
  $Matches[1]
}

$differenz = $celsiusPalma - $celsiusHannover

"In Palma de Mallorca ist es gerade $differenz Grad Celsius wärmer."

# HTML-Report der Wetterdaten anlegen und öffnen:
$mallorca.currentweather, $hannover.currentweather |
Select-Object Location, Time, Wind, Visibility, Temperature, DewPoint, RelativeHumidity, Pressure, Status |
ConvertTo-Html -Title 'Wetterbericht Palma und Hannover' |
Out-File $env:temp\wetter.hta
Invoke-Item $env:temp\wetter.hta


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
