﻿function New-NETObject
{
  [CmdletBinding()]
 
  param
  (
    [type]
    $TypeName
  )

  dynamicparam
  {
    if (-not ($TypeName.IsClass -and !$TypeName.GetConstructor([Type]::EmptyTypes)))
    {
      $paramDictionary = New-Object -TypeName System.Management.Automation.RuntimeDefinedParameterDictionary
      $Properties = $TypeName.GetProperties() | Where-Object CanWrite

      foreach ($Property in $Properties)
      {
        $attributes = New-Object System.Management.Automation.ParameterAttribute
        $attributes.ParameterSetName = '__AllParameterSets'
        $attributes.Mandatory = $false
        $attributeCollection =
          New-Object -TypeName System.Collections.ObjectModel.Collection[System.Attribute]
        $attributeCollection.Add($attributes)
        $dynParam1 = New-Object -TypeName System.Management.Automation.RuntimeDefinedParameter($Property.Name,
         $Property.PropertyType, $attributeCollection)
        $paramDictionary.Add($Property.Name, $dynParam1)
      }

      $paramDictionary
    }
  }

  end
  {
    $null = $PSBoundParameters.Remove('TypeName')
    $PSBoundParameters -as $TypeName
  }
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
