﻿# Erweiterung für die Vervollständigung mit Prozessnamen zur Laufzeit:
$completion_Process = {
    param($commandName, $parameterName, $wordToComplete, $commandAst, $fakeBoundParameter)
    
    Get-Process | 
      Sort-Object -Property Name -Unique | 
      Where-Object { $_.Name -like "$wordToComplete*" } |
      ForEach-Object {
        New-Object System.Management.Automation.CompletionResult $_.Name, $_.Name, 'ParameterValue', ('{0} ({1})' -f $_.Description, $_.ID) 
    }
}

# Erweiterung in globale Variable aufnehmen und festlegen, dass die Erweiterung für die
# Funktion "Test-DynamicArguments" und dessen Parameter "ProcessName" gelten soll:
if (-not $global:options) { 
  $global:options = @{CustomArgumentCompleters = @{};NativeArgumentCompleters = @{}}
}
$global:options['CustomArgumentCompleters']['Test-DynamicArguments:ProcessName'] = $Completion_Process

# PowerShell-Codevervollständigung um die selbstdefinierten Erweiterung(en) ergänzen:
$function:tabexpansion2 = $function:tabexpansion2 -replace 'End\r\n{','End { if ($null -ne $options) { $options += $global:options} else {$options = $global:options}'

# Funktion besitzt nun eine dynamische Autovervollständigung für ihren Parameter "ProcessName":
function Test-DynamicArguments
{
    param
    (
        $ProcessName
    )

    "Hello $ProcessName"
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
