﻿Function Test-DynamicParameter
{
  [CmdletBinding()]

  param
  ([Int]$Count)

  dynamicparam
  {
    $paramDictionary = New-Object -TypeName System.Management.Automation.RuntimeDefinedParameterDictionary

    ForEach ($Property in (1..$Count))
    {
      $attributes = New-Object System.Management.Automation.ParameterAttribute
      $attributes.ParameterSetName = '__AllParameterSets'
      $attributes.Mandatory = $false
      $attributeCollection = New-Object -TypeName System.Collections.ObjectModel.Collection[System.Attribute]
      $attributeCollection.Add($attributes)
      $Name = "Param$Property"
      $dynParam = New-Object -TypeName System.Management.Automation.RuntimeDefinedParameter($Name, [Int32], $attributeCollection)
      $paramDictionary.Add($Name, $dynParam)
    }

    $paramDictionary
  }

  end
  {
    "Die übergebenen Parameter:"
    $PSBoundParameters
  }
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
