﻿function Out-LogFile
{
    param
    (
        [Parameter(Mandatory=$true)]
        $Path,

        [Parameter(ValueFromPipeline=$true)]
        $InputObject
    )

    begin
    {
        # Zugriff auf das Cmdlet, an das die Daten geliefert werden sollen:
        $Cmdlet = 'Out-File'
        $wrappedCmd = $ExecutionContext.InvokeCommand.GetCommand($cmdlet, 'Cmdlet')

        # Befehlszeile festlegen. $wrappedCmd steht für das Cmdlet "Out-File":
        $scriptCmd = {&  $wrappedCmd -FilePath $Path -Append }

        # Zugriff auf diesen Befehl erhalten:
        $steppablePipeline = $scriptCmd.GetSteppablePipeline($myInvocation.CommandOrigin)

        # begin-Block von "Out-File" aufrufen:
        $steppablePipeline.Begin($PSCmdlet)
}

    process
    {
        # process-Bock von "Out-File" aufrufen:
        $steppablePipeline.Process($_)

        # HIER DIE ERWEITERUNG: 
        # AUSSERDEM das einlaufende Element in die Konsole zurückgeben:
        $_
    }

    end
    {
        # end-Block von "Out-File" aufrufen:
        $steppablePipeline.End()
    }
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
