﻿
Function Test-Certificate
{
  param
  (
    [System.Security.Cryptography.X509Certificates.X509Certificate2]
    $Certificate
  )

  $ok = $zertifikat.Verify()

  if (-not $ok)
  {
    Add-Type -AssemblyName System.Security
    $chain = New-Object System.Security.Cryptography.X509Certificates.X509Chain
    $chain.Build($zertifikat)
    $reason = $chain.ChainStatus
    $reason
  }
  else
  {
    $rv = 1 | Select-Object -Property Status, StatusInformation
    $rv.Status = 'OK'
    $rv.StatusInformation = 'Trusted by local system.'
    $rv
  }
}


$name = 'Test'
$zertifikat = Get-ChildItem -Path cert:\CurrentUser\My | Where-Object { $_.Subject -like "CN=$Name" }
Test-Certificate -Certificate $zertifikat


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
