﻿function Get-FirewallRule($rule = '*', $port = '*') {
  try {
    (New-Object -ComObject HNetCfg.FwPolicy2).Rules | 
      Where-Object { $_.Name -like $rule } | 
      Where-Object { $_.LocalPorts -like $port 
    }
  }
  catch [system.Management.Automation.PSArgumentException] {
    # this handles firewall rules on Windows XP:
    0..2 | ForEach-Object {
      $obj = New-Object -ComObject HnetCfg.FwMgr
    }{ 
      try {
        $obj.LocalPolicy.GetProfileByType($_).GloballyOpenPorts 
        } catch {}} | 
        Where-Object { $_.Name -like $rule } | 
        Where-Object { $_.Port.toString() -like $port 
    }
  }
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
