﻿Function Get-RemotingCmdlet
{
  $CredSupport = @{
    Name = 'SupportsCredential'
    Expression = { $_.Parameters.ContainsKey('Credential') }
  }

  # alle Module von Microsoft importieren:
  Get-Module -ListAvailable |
    Where-Object { $_.Author -eq 'Microsoft Corporation' } |
    Import-Module 

  Get-Command -ListImported | 
    Where-Object RemotingCapability -like '*Command' |
    Select-Object -Property Name, RemotingCapability, $CredSupport |
    Sort-Object -Property RemotingCapability, Name
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
