﻿function Set-RemoteDesktop
{
  param
  (
    $ComputerName,

    $Credential,

    [switch]
    $Disable
  )

  # diesen Parameter nicht an Invoke-Command weitergeben
  $null = $PSBoundParameters.Remove('Disable')

  $code = {
    param([bool]$Disable)

    $key = 'HKLM:\SYSTEM\CurrentControlSet\Control\Terminal Server'
    if ($Disable) {
        $Value = 1
    }
    else {
        $Value = 0
    }
     Set-ItemProperty -Path $key -Name fDenyTSConnections -Value ([int]$Value ) -Type DWORD

    if ($Disable)
    {
      netsh.exe advfirewall firewall set rule group="Remotedesktop " new enable=no
      Write-Warning "Remote Desktop disabled on \\$env:COMPUTERNAME"
    }
    else
    {
      netsh.exe advfirewall firewall set rule group="Remotedesktop " new enable=yes
      Write-Warning "Remote Desktop enabled on \\$env:COMPUTERNAME"
    }
  }

  Invoke-Command -ScriptBlock $code @PSBoundParameters -ArgumentList $Disable
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
