﻿$code = {
    param
    (
      # der Text für die Laufschrift:
      #[String[]]
      $Text,
      # eine Referenz auf den Host ($host)
      $theHost,
      # die Verzögerung für die Laufschrift:
      $Delay
    )

    # die einzelnen Texte werden mit Get-Random zufällig angeordnet,
    # damit bei jedem Start eine andere Reihenfolge gewählt wird:
    $Text = Get-Random -InputObject $text -count $Text.Length

    # aus den Einzeltexten wird ein Gesamttext gemacht:
    $Text = $Text -join ' '

    # es wird berechnet, wie oft der Text wiederholt werden muss, um mindestens
    # 1600 Zeichen lang zu sein (doppelte Länge der geplanten Anzeigenbreite
    # von 800 Zeichen):
    $TextLength = $Text.Length
    # aufrunden:
    $Factor = [Math]::Ceiling((1600 / $TextLength))
    $Text = $Text * $Factor

    # verdoppeln:
    $Text = $Text * 2

    # eine Endlosschleife:
    do
    {
      # in 3er Schritten von 0 bis Textende:
      For ($x=0; $x -lt $TextLength; $x+=3)
      {
        # in der Titelleiste des Fensters den Anfang des Textes entsprechend verschieben:
        $theHost.UI.RawUI.WindowTitle = $Text.Substring($x,800)
        # eingebaute Verzögerung:
        Start-Sleep -Milliseconds $Delay
      }
    } while ($true)
  }

  & $code -Text (Get-Newsticker) -theHost $host -Delay 200

################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
