﻿function Monitor-Folder {
     param([string]$folder)

    $fsw = New-Object System.IO.FileSystemWatcher
    $fsw.Path = $folder

    $global:folderchange = @()

    $action = {
        [System.Console]::Beep(440,100)
  $info = @{}
  $info.Path = $eventArgs.FullPath
  $info.Type = $eventArgs.ChangeType
  $info.Timestamp = (Get-Date)
  $global:folderchange += (New-Object PSObject -Property $info)
    }

    Register-ObjectEvent $fsw -EventName Created -Action $action -SourceIdentifier Watch1 | Out-Null
    Register-ObjectEvent $fsw -EventName Changed -Action $action -SourceIdentifier Watch2 | Out-Null
    Register-ObjectEvent $fsw -EventName Deleted -Action $action -SourceIdentifier Watch3 | Out-Null
}

function Unmonitor-Folder {
  Unregister-Event Watch*
  Remove-Job -Name Watch*
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
