﻿function Get-ISEVariable
{
  # Inhalt des aktuellen Skripts im ISE-Editor lesen:
  $text = $psISE.CurrentFile.Editor.Text

  # alle Variablen im Code in finden
   [System.Management.Automation.PSParser]::Tokenize($text, [ref]$null) |
    Where-Object { $_.Type -eq 'Variable' } |
    # Name der Variable finden
    ForEach-Object {
        $rv = 1 | Select-Object -Property Line, Name, Code
        $rv.Name = $text.Substring($_.Start, $_.Length)
        $rv.Line = $_.StartLine

        # die Zeile, in der die Variable steht, als Text lesen:
        $psISE.CurrentFile.Editor.SetCaretPosition($_.StartLine,1)
        $psISE.CurrentFile.Editor.SelectCaretLine()
        $rv.Code = $psISE.CurrentFile.Editor.SelectedText.Trim()

        # Informationen zurückliefern
        $rv
    }
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
