﻿
Function Remove-ISEComment
{
  # Inhalt des aktuellen Skripts im ISE-Editor lesen:
  $text = $psise.CurrentFile.Editor.Text
  $sb = New-Object System.Text.StringBuilder $text

  # alle Kommentare im Code in umgekehrter Reihenfolge finden
  # (letzter Kommentar zuerst):
  $comments = [System.Management.Automation.PSParser]::Tokenize($text, [ref]$null) |
    Where-Object { $_.Type -eq 'Comment' } |
    Sort-Object -Property Start -Descending |
    # alle Textstellen im Editor entfernen
    ForEach-Object {
        $sb.Remove($_.Start, $_.Length)
    
    }
    
    # Aktualisierten Text in Editor ersetzen:
    $psise.CurrentFile.Editor.Text = $sb.toString() 
}

################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
