﻿Function Rename-ISEVariable
{
    param
    (
        $OldName,

        $NewName
    )

    $OldName = $OldName.TrimStart('$')
    $NewName = $NewName.TrimStart('$')


  # Inhalt des aktuellen Skripts im ISE-Editor lesen:
  $text = $psise.CurrentFile.Editor.Text

  # für die schnelle Bearbeitung des Textes diesen in einen "StringBuilder" laden:
  $sb = New-Object System.Text.StringBuilder $text

  # alle Variablen im Code in umgekehrter Reihenfolge finden
  # (letzte Variable zuerst):
  $variables = [System.Management.Automation.PSParser]::Tokenize($text, [ref]$null) |
    Where-Object { $_.Type -eq 'Variable' } |
    Sort-Object -Property Start -Descending |
    # nur die gewünschte Variable ändern
    Where-Object {
       $text.SubString($_.Start+1, $_.Length-1) -eq $OldName
    } |
    # alle Textstellen im Editor umbenennen
    ForEach-Object {
       $sb.Remove($_.Start+1, $_.Length-1)
       $sb.Insert($_.Start+1, $NewName)
    }
    
    # Aktualisierten Text in Editor ersetzen:
    $psise.CurrentFile.Editor.Text = $sb.toString() 
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
