﻿

function Find-AddonMenu
{
    param(
        $Title = '*',
        $MenuItem = $psise.CurrentPowerShellTab.AddOnsMenu,
        [Switch]
        $Recurse
    )

    foreach($item in $MenuItem.SubMenus)
    {
        if ($Recurse)
        {
        Find-AddonMenu -Title $title -MenuItem $item
        }
        
        if ($item.DisplayName -like "*$Title*")
        {
            $item
        }
    }
}

function New-AddonMenu
{
    param
    (
        [Parameter(Mandatory=$true)]
        $DisplayName,

        [ScriptBlock]
        $Action=$null,

        $Shortcut=$null
    )
    try
    {
        $Parent = $psise.CurrentPowerShellTab.AddOnsMenu
        $Items = $DisplayName -split '\\'
        for($x=0; $x -lt $Items.Count-1; $x++) 
        {
            $name = $Items[$x]
            $item = Find-AddonMenu -Title $name -MenuItem $parent
            if ($item -eq $null)
            {
                $item = $parent.SubMenus.Add($name, $null, $null)
            }
            $parent = $item
        }


        $item = Find-AddonMenu -Title $Items[-1] -MenuItem $parent
        if ($item -ne $null)
        {
            Write-Warning 'Menu item already exists.'
            break
        }    

        try
        {
            $parent.SubMenus.Add($Items[-1], $Action, $Shortcut)
        }
        catch
        {
            try
            {
                $parent.SubMenus.Add($Items[-1], $Action, $null)
            }
            catch
            {
                Write-Warning "Unable to create addon menu item: $_"
            }
        }
    }
    catch
    {
        Write-Warning "Unable to create addon menu item: $_"
    }

}

function Remove-AddonMenu
{
    param
    (
        [Parameter(Mandatory=$true)]
        $DisplayName
    )

    $Parent = $psise.CurrentPowerShellTab.AddOnsMenu
    $Items = $DisplayName -split '\\'
    $MenuItems = @($psise.CurrentPowerShellTab.AddOnsMenu)
    for($x=0; $x -lt $Items.Count; $x++) 
    {
        $name = $Items[$x]
        $parent = Find-AddonMenu -Title $name -MenuItem $parent
        $MenuItems += $parent
    }

    for($x=$MenuItems.Count -1; $x -gt 0; $x--)
    {
        if ($MenuItems[$x].SubMenus.Count -eq 0)
        {
            $null = $MenuItems[$x-1].Submenus.Remove($MenuItems[$x])
        }
    }
}

################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
