﻿Function Out-PDF
{
  param
  (
    $Path = "$env:temp\$(Get-Random).pdf",
    $Text = $null,
    $Title = $null,
    $Font = 'Courier',
    $FontSize = 12,
    $Width = 80,
    [Switch]$Open,
    [switch]$Landscape
  )

  if ($Text -eq $null)
  {
    $Text = $Input | Out-String -Width $Width
  }

  $WordObj = New-Object -ComObject Word.Application
  $document = $WordObj.Documents.Add()
  $document.PageSetup.Orientation = [Int][bool]$Landscape
  $document.Content.Text = $Text
  $document.Content.Font.Size = $FontSize
  $document.Content.Font.Name = $Font

  if ($Title -ne $null)
  {
    $WordObj.Selection.Font.Name = $Font
    $wordobj.Selection.Font.Size = 20
    $wordobj.Selection.TypeText($Title)
    $wordobj.Selection.ParagraphFormat.Alignment = 1
    $wordobj.Selection.TypeParagraph()
    $wordobj.Selection.TypeParagraph()
  }

  $saveaspath = [ref]$Path
  $formatPDF = [ref] 17
  $document.SaveAs($saveaspath,$formatPDF)
  $wdDoNotSaveChanges = 0
  $WordObj.NormalTemplate.Saved = $true
  $WordObj.Visible = $true
  $document.Close([ref]$wdDoNotSaveChanges)
  $WordObj.Quit([ref]$wdDoNotSaveChanges)

  if ($Open)
  {
    Invoke-Item -Path $Path
  }
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
