﻿Function Get-Matches
{
  param
  (
    [Parameter(Mandatory=$true)]
    $Pattern,

    [Parameter(ValueFromPipeline=$true)]
    $InputObject
  )

  Begin
  {
    try {
      $regex = New-Object Regex($pattern)
    }
    catch {
      Throw "Get-Matches: Pattern not correct. '$Pattern' is no valid regular expression."
    }
    $groups = @($regex.GetGroupNames() |
      Where-Object { ($_ -as [Int32]) -eq $null } |
      ForEach-Object { $_.toString() })
  }

  Process
  {
    ForEach ($line in $InputObject)
    {
      ForEach ($match in ($regex.Matches($line)))
      {
        if ($groups.Count -eq 0)
        {
          ([Object[]]$match.Groups)[-1].Value
        }
        else
        {
          $rv = 1 | Select-Object -Property $groups
          $groups | ForEach-Object {
            $rv.$_ = $match.Groups[$_].Value
          }
          $rv
        }
      }
    }
  }
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
