﻿# benötigt PowerShell 3.0!

# alle Links von dieser Webseite holen:
$url = 'http://www.tagesschau.de'

# Muster, um <a...></a>-Struktur auszuwerten:
$pattern = '<a href="(?<url>.*?)".*?>(?:<.*?>){0,}(?<title>.*?)(?:<.*?>){0,}</a>'

# Inhalt der Webseite abrufen (erfordert PowerShell 3.0):
$website = Invoke-WebRequest -UseBasicParsing -Uri $url

# alle Hyperlinks parsen:
$website.Links | Select-Object -ExpandProperty outerHTML | ForEach-Object {
  # trifft der Reguläre Ausdruck zu?
  if ($_ -match $pattern)
  {
    # ja, also dann findet sich der Linktitel jetzt in $matches.title
    # und die URL in $matches.url
    # falls Titel leer ist oder URL mit '#' beginnt, überspringen:
    if (($matches.title.Trim()) -ne '' -and ($matches.url.StartsWith('#') -eq $false))
    {
      # ein neues leeres Objekt mit den Eigenschaften "Title" und "URL" anlegen:
      $ergebnis = New-Object PSObject | Select-Object Title, URL

      # wenn die URL mit '/' beginnt, ist sie relativ
      if ($matches.url.StartsWith('/'))
      {
        # dann die URL der Homepage voranstellen:
        $ergebnis.URL = $url + $matches.url
      }
      else
      {
        # sonst die URL unverändert übernehmen:
        $ergebnis.URL = $matches.url
      }

      # Titel des Links in Objekt aufnehmen:
      $ergebnis.Title = $matches.title
      # Objekt dann als Ergebnis zurückgeben:
      $ergebnis
    }
  }
  # schließlich noch nach "Title" sortieren und im GridView ausgeben:
} | Sort-Object -Property Title |
Out-GridView -Title 'Aktuelle Links der Tagesschau-Webseite'  


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
