﻿# alle Links von dieser Webseite holen:
$url = 'http://www.tagesschau.de'

# Muster, um <a...></a>-Struktur auszuwerten:
$pattern = '<a href="(?<url>.*?)".*?>(?:<.*?>){0,}(?<title>.*?)(?:<.*?>){0,}</a>'

# Inhalt der Webseite abrufen (funktioniert in dieser Weise nur bei direktem Internetzugang):
$webclient = New-Object System.Net.WebClient
$webclient.Encoding = [System.Text.Encoding]::UTF8

# Webseiteninhalt abrufen und als Gesamttext zusammenfügen:
$html = $webclient.DownloadString($url) | Out-String

# HTML parsen:
Get-Matches -Pattern $pattern -InputObject $html | ForEach-Object {
  # Linktitel findet sich jetzt in $_.title
  # und die URL in $_.url
  # falls Titel leer ist oder URL mit '#' beginnt, überspringen:

  if (($_.title.Trim()) -ne '' -and ($_.url.StartsWith('#') -eq $false))
  {
    # ein neues leeres Objekt mit den Eigenschaften "Title" und "URL" anlegen:
    $ergebnis = New-Object PSObject | Select-Object Title, URL

    # wenn die URL mit '/' beginnt, ist sie relativ

    if ($_.url.StartsWith('/'))
    {
      # dann die URL der Homepage voranstellen:
      $ergebnis.URL = $url + $_.url
    }
    else
    {
      # sonst die URL unverändert übernehmen:
      $ergebnis.URL = $_.url
    }

    # Titel des Links in Objekt aufnehmen:
    $ergebnis.Title = $_.title
    # Objekt dann als Ergebnis zurückgeben:
    $ergebnis
  }

  # schließlich noch nach "Title" sortieren:
} | Sort-Object -Property Title |
Out-GridView -Title 'Aktuelle Links der Tagesschau-Webseite'


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
