﻿function Get-DerivedException {
  param
  (
    [Parameter(Mandatory=$true)]
    $ExceptionName
  )

  # alle geladenen .NET-Assemblies...
  [AppDomain]::CurrentDomain.GetAssemblies() |
    # ...auf alle exportierten Typen durchsuchen (falls möglich)... 
    ForEach-Object { try {$_.GetExportedTypes()} catch {} } | 
    # ...aber nur solche, die im Namen "Exception" tragen...
    Where-Object { $_.Name -like '*Exception*' } |
    # ...und nur solche, die vom angegebenen Typ abgeleitet sind...
    Where-Object { $_.BaseType -like $ExceptionName } |
    # ...und davon bitte den Namen:
    Select-Object -ExpandProperty Name
}


################################################################
#
# VERWENDUNG DIESES SKRIPTS AUF EIGENE GEFAHR / OHNE ZUSICHERUNG
#
# Wichtiger Hinweis:
#
# Dieses PowerShell-Skript stammt aus den Begleitmedien des Buches
# "Scripting mit Windows PowerShell 3.0 - Der Workshop" von 
# Dr. Tobias Weltner, erschienen 2013 beim Verlag Microsoft Press
# (ISBN-13: 978-3-86645-687-7).
#
# Das Skript und seine Funktion werden im Buch erläutert und liegen
# in dieser Datei vor, um die Eingabe des Codes zu erleichtern.
#
# Bitte vergewissern Sie sich im Kontext des Buches und des jeweiligen
# Kapitels, was die Aufgabe und Funktionsweise dieses Skripts ist, 
# und dass das Skript vollständig dem abgedruckten Code im Buch entspricht. 
#
# Weder Autor noch Verlag übernehmen eine Haftung für Folgen, die durch die Ausführung
# dieses Skripts entstehen.
#
################################################################
